--[[
	Copyright (C) 2012 humfras & Nymbia

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
]]
local _G = getfenv(0)
local L = AceLibrary("AceLocale-2.2"):new("SpellBinder")
SpellBinder = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local verticalbuttonspacing = -2
local awaitinginput=false
local currentmode --one of "spell" "macro" or "item"
local currentitem --the item we're gonna add a binding to, ie "Fireball(Rank 5)" or "Major Mana Potion"
local currentbind1 --the binding that we're gonna add to the item
local currentbind2
BINDING_HEADER_SpellBinder = L["SpellBinder"]
BINDING_NAME_SpellBinder = L["SpellBinder"]

function print(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)
	
	if arg1 == nil and arg2~=nil then arg1='nil' end
	if arg2 == nil and arg3~=nil then arg2='nil' end
	if arg3 == nil and arg4~=nil then arg3='nil' end
	if arg4 == nil and arg5~=nil then arg4='nil' end
	if arg5 == nil and arg6~=nil then arg5='nil' end
	if arg6 == nil and arg7~=nil then arg6='nil' end
	if arg7 == nil and arg8~=nil then arg7='nil' end
	if arg8 == nil and arg9~=nil then arg8='nil' end
	if arg9 == nil and arg10~=nil then arg9='nil' end
	if arg10 == nil and arg11~=nil then arg10='nil' end
	if arg11 == nil and arg12~=nil then arg11='nil' end
	if arg12 == nil and arg13~=nil then arg12='nil' end
	if arg13 == nil and arg14~=nil then arg13='nil' end
	if arg14 == nil and arg15~=nil then arg14='nil' end
	if arg15 == nil and arg16~=nil then arg15='nil' end
	if arg16 == nil and arg17~=nil then arg16='nil' end
	if arg17 == nil and arg18~=nil then arg17='nil' end
	if arg18 == nil and arg19~=nil then arg18='nil' end
	if arg19 == nil and arg20~=nil then arg19='nil' end
	
	local t = {arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20}
	
	local returnstring = ""
	local division = ", "
	local maxi = getn(t)
	
	for i=1,maxi do
		if i == maxi then
			division = ""
		end
		returnstring = returnstring..t[i]..division
	end
	
	DEFAULT_CHAT_FRAME:AddMessage(returnstring)
end

--feel free to correct this crap if it's wrong.
local bindables = {
	'ESCAPE', "`", 'TAB', 'SPACE', 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', 'A', 'S',
	'D', 'F', 'G', 'H', 'J', 'K', 'L', 'Z', 'X', 'C', 'V', 'B', 'N', 'M', '-', '=', '[', ']',
	'\\', ';', "'", '.', '/', ',', 'ENTER', 'MOUSEWHEELUP', 'MOUSEWHEELDOWN', 'BACKSPACE', 'DELETE',
	'INSERT', 'HOME', 'END', 'PAGEUP', 'PAGEDOWN', 'NUMLOCK', 'NUMPADSLASH', 'NUMPADMULTIPLY', 'NUMPADMINUS',
	'NUMPADPLUS', 'NUMPADENTER', 'NUMPADPERIOD', "^", "+", "#", "<",
}-- because of XML limitations: "/lt" = "<"	-	see 'specialxml'-table for reference
for i = 0, 9 do
	bindables[getn(bindables)+1] = tostring(i)
	bindables[getn(bindables)+1] = 'NUMPAD'..i
end
for i = 1, 12 do
	bindables[getn(bindables)+1] = 'F'..i
end
for i = 1, 5 do
	bindables[getn(bindables)+1] = 'BUTTON'..i
end
local modifiers = { -- order: alt-ctrl-shift-
	'', 'ALT-', 'CTRL-', 'SHIFT-', 'ALT-CTRL-', 'ALT-SHIFT-', 'CTRL-SHIFT-', 'ALT-CTRL-SHIFT-'
}
local specialxml = {
	"<",
}
local specialxmlchars = {
	["<"] = "/lt",
	["ALT-<"] = "ALT-/lt",
	["SHIFT-<"] = "SHIFT-/lt",
	["ALT-SHIFT-<"] = "ALT-SHIFT-/lt",
	["CTRL-<"] = "CTRL-/lt",
	["ALT-CTRL-SHIFT-<"] = "ALT-CTRL-SHIFT-/lt",
	["CTRL-SHIFT-<"] = "CTRL-SHIFT-/lt",
	["ALT-CTRL-<"] = "ALT-CTRL-/lt",
}


--the slash commands
local options = {
	type = 'execute',
	name = L["SpellBinder"],
	desc = L["SpellBinder"],
	func = function()
		SpellBinder:Toggle()
	end,
}

function SpellBinder:OnInitialize()
	self:RegisterChatCommand({"/spellbinder", "/spellbind", "/sb"}, options)
	if not SpellBinder_Assignments then
		SpellBinder_Assignments = {}
	end
	if not SpellBinder_Keystate then
		SpellBinder_Keystate = "down"
	end
	SpellBinder:UseAutoUnstuck()
end

function SpellBinder:OnEnable()
	self:RegisterEvent("SPELLS_CHANGED")
end

function SpellBinder:OnDisable()
	if SpellBinderFrame then
		SpellBinderFrame:Hide()
	end
end

function SpellBinder:Toggle()
	if not SpellBinderFrame then
		local previousframe
		local SpellBinderFrame = CreateFrame("Frame","SpellBinderFrame",UIParent)
		SpellBinderFrame:SetFrameStrata("DIALOG")
		SpellBinderFrame:SetWidth(350)
		SpellBinderFrame:SetHeight(270)
		SpellBinderFrame:SetBackdrop( {
		  bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = false, tileSize = 16, edgeSize = 16,
		  insets = { left = 5, right = 5, top = 5, bottom = 5 }
		})
		SpellBinderFrame:SetBackdropColor(0,0,0)
		SpellBinderFrame:EnableMouse(true)
		SpellBinderFrame:SetMovable(true)
		SpellBinderFrame:SetPoint("CENTER",0,0)
		SpellBinderFrame:SetScript("OnMouseDown", function() this:StartMoving() end)
		SpellBinderFrame:SetScript("OnMouseUp", function() this:StopMovingOrSizing() end)

	--RIGHT Buttons
		local SpellBinderFrameListButton = CreateFrame("Button","SpellBinderFrameListButton",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameListButton:SetFrameStrata("DIALOG")
		SpellBinderFrameListButton:SetWidth(40)
		SpellBinderFrameListButton:SetHeight(20)
		SpellBinderFrameListButton:SetPoint("TOPRIGHT", SpellBinderFrame, "TOPRIGHT", -10, -10)
		SpellBinderFrameListButton:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
		SpellBinderFrameListButton:SetScript("OnClick", function() SpellBinder:MakeListMenu() end)
		SpellBinderFrameListButton:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameListButton:Enable()
		SpellBinderFrameListButton:SetTextColor(1, 1, 1)
		SpellBinderFrameListButton:SetText(L["List"])
		previousframe = nil

		local SpellBinderFrameKeyBindButton1 = CreateFrame("Button","SpellBinderFrameKeyBindButton1",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameKeyBindButton1:SetFrameStrata("DIALOG")
		SpellBinderFrameKeyBindButton1:SetWidth(140)
		SpellBinderFrameKeyBindButton1:SetHeight(24)
		SpellBinderFrameKeyBindButton1:SetPoint("TOPRIGHT", SpellBinderFrame, "TOPRIGHT", -10, -110)
		SpellBinderFrameKeyBindButton1:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
		SpellBinderFrameKeyBindButton1:SetScript("OnClick", function() SpellBinder:Press(1, arg1) end)
		SpellBinderFrameKeyBindButton1:SetScript("OnKeyDown", function() SpellBinder:Press(1, nil, arg1) end)
		SpellBinderFrameKeyBindButton1:SetScript("OnMouseWheel", function() if arg1 == 1 then SpellBinder:Press(1, "MOUSEWHEELUP") else SpellBinder:Press(1, "MOUSEWHEELDOWN") end end)
		SpellBinderFrameKeyBindButton1:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameKeyBindButton1:Enable()
		SpellBinderFrameKeyBindButton1:SetTextColor(1, 1, 1)
		SpellBinderFrameKeyBindButton1:SetText(L["Click to Set"])
		previousframe = SpellBinderFrameKeyBindButton1

		local SpellBinderFrameKeyBindButton2 = CreateFrame("Button","SpellBinderFrameKeyBindButton2",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameKeyBindButton2:SetFrameStrata("DIALOG")
		SpellBinderFrameKeyBindButton2:SetWidth(140)
		SpellBinderFrameKeyBindButton2:SetHeight(24)
		SpellBinderFrameKeyBindButton2:SetPoint("TOP", previousframe, "BOTTOM", 0, -4)
		SpellBinderFrameKeyBindButton2:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
		SpellBinderFrameKeyBindButton2:SetScript("OnClick", function() SpellBinder:Press(2, arg1) end)
		SpellBinderFrameKeyBindButton2:SetScript("OnKeyDown", function() SpellBinder:Press(2, nil, arg1) end)
		SpellBinderFrameKeyBindButton2:SetScript("OnMouseWheel", function() if arg1 == 1 then SpellBinder:Press(2, "MOUSEWHEELUP") else SpellBinder:Press(2, "MOUSEWHEELDOWN") end end)
		SpellBinderFrameKeyBindButton2:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameKeyBindButton2:Enable()
		SpellBinderFrameKeyBindButton2:SetTextColor(1, 1, 1)
		SpellBinderFrameKeyBindButton2:SetText(L["Click to Set"])
		previousframe = SpellBinderFrameKeyBindButton2

	--LEFT buttons
		local SpellBinderFrameSpellBook1Button = CreateFrame("Button","SpellBinderFrameSpellBook1Button",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameSpellBook1Button:SetFrameStrata("DIALOG")
		SpellBinderFrameSpellBook1Button:SetWidth(140)
		SpellBinderFrameSpellBook1Button:SetHeight(24)
		SpellBinderFrameSpellBook1Button:SetPoint("TOPLEFT",SpellBinderFrame, 10, -10)
		SpellBinderFrameSpellBook1Button:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameSpellBook1Button:SetScript("OnClick", function() SpellBinder:ClickBookButton(1) end)
		SpellBinderFrameSpellBook1Button:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameSpellBook1Button:Enable()
		SpellBinderFrameSpellBook1Button:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameSpellBook1Button

		local SpellBinderFrameSpellBook2Button = CreateFrame("Button","SpellBinderFrameSpellBook2Button",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameSpellBook2Button:SetFrameStrata("DIALOG")
		SpellBinderFrameSpellBook2Button:SetWidth(140)
		SpellBinderFrameSpellBook2Button:SetHeight(24)
		SpellBinderFrameSpellBook2Button:SetPoint("TOP", previousframe, "BOTTOM", 0, -verticalbuttonspacing)
		SpellBinderFrameSpellBook2Button:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameSpellBook2Button:SetScript("OnClick", function() SpellBinder:ClickBookButton(2) end)
		SpellBinderFrameSpellBook2Button:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameSpellBook2Button:Enable()
		SpellBinderFrameSpellBook2Button:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameSpellBook2Button

		local SpellBinderFrameSpellBook3Button = CreateFrame("Button","SpellBinderFrameSpellBook3Button",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameSpellBook3Button:SetFrameStrata("DIALOG")
		SpellBinderFrameSpellBook3Button:SetWidth(140)
		SpellBinderFrameSpellBook3Button:SetHeight(24)
		SpellBinderFrameSpellBook3Button:SetPoint("TOP", previousframe, "BOTTOM", 0, -verticalbuttonspacing)
		SpellBinderFrameSpellBook3Button:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameSpellBook3Button:SetScript("OnClick", function() SpellBinder:ClickBookButton(3) end)
		SpellBinderFrameSpellBook3Button:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameSpellBook3Button:Enable()
		SpellBinderFrameSpellBook3Button:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameSpellBook3Button

		local SpellBinderFrameSpellBook4Button = CreateFrame("Button","SpellBinderFrameSpellBook4Button",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameSpellBook4Button:SetFrameStrata("DIALOG")
		SpellBinderFrameSpellBook4Button:SetWidth(140)
		SpellBinderFrameSpellBook4Button:SetHeight(24)
		SpellBinderFrameSpellBook4Button:SetPoint("TOP", previousframe, "BOTTOM", 0, -verticalbuttonspacing)
		SpellBinderFrameSpellBook4Button:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameSpellBook4Button:SetScript("OnClick", function() SpellBinder:ClickBookButton(4) end)
		SpellBinderFrameSpellBook4Button:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameSpellBook4Button:Enable()
		SpellBinderFrameSpellBook4Button:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameSpellBook4Button

		local SpellBinderFrameSpellBook5Button = CreateFrame("Button","SpellBinderFrameSpellBook5Button",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameSpellBook5Button:SetFrameStrata("DIALOG")
		SpellBinderFrameSpellBook5Button:SetWidth(140)
		SpellBinderFrameSpellBook5Button:SetHeight(24)
		SpellBinderFrameSpellBook5Button:SetPoint("TOP", previousframe, "BOTTOM", 0, -verticalbuttonspacing)
		SpellBinderFrameSpellBook5Button:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameSpellBook5Button:SetScript("OnClick", function() SpellBinder:ClickBookButton(5) end)
		SpellBinderFrameSpellBook5Button:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameSpellBook5Button:Enable()
		SpellBinderFrameSpellBook5Button:SetText(L["Pet"])
		SpellBinderFrameSpellBook5Button:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameSpellBook5Button

		local SpellBinderFrameItemButton = CreateFrame("Button","SpellBinderFrameItemButton",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameItemButton:SetFrameStrata("DIALOG")
		SpellBinderFrameItemButton:SetWidth(140)
		SpellBinderFrameItemButton:SetHeight(24)
		SpellBinderFrameItemButton:SetPoint("TOP", previousframe, "BOTTOM", 0, -verticalbuttonspacing)
		SpellBinderFrameItemButton:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameItemButton:SetScript("OnClick", function() SpellBinder:ClickItemButton() end)
		SpellBinderFrameItemButton:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameItemButton:Enable()
		SpellBinderFrameItemButton:SetText(L["Item"])
		SpellBinderFrameItemButton:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameItemButton

		local SpellBinderFrameMacroButton = CreateFrame("Button","SpellBinderFrameMacroButton",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameMacroButton:SetFrameStrata("DIALOG")
		SpellBinderFrameMacroButton:SetWidth(140)
		SpellBinderFrameMacroButton:SetHeight(24)
		SpellBinderFrameMacroButton:SetPoint("TOP", previousframe, "BOTTOM", 0, -verticalbuttonspacing)
		SpellBinderFrameMacroButton:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameMacroButton:SetScript("OnClick", function() SpellBinder:ClickMacroButton() end)
		SpellBinderFrameMacroButton:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameMacroButton:Enable()
		SpellBinderFrameMacroButton:SetText(L["Macro"])
		SpellBinderFrameMacroButton:SetTextColor(1, 1, 1)
		previousframe = SpellBinderFrameMacroButton

		
	--CLOSE button
		local SpellBinderFrameCloseButton = CreateFrame("Button","SpellBinderFrameCloseButton",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameCloseButton:SetFrameStrata("DIALOG")
		SpellBinderFrameCloseButton:SetWidth(100)
		SpellBinderFrameCloseButton:SetHeight(24)
		SpellBinderFrameCloseButton:SetPoint("BOTTOMRIGHT",SpellBinderFrame, -10, 10)
		SpellBinderFrameCloseButton:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameCloseButton:SetScript("OnClick", function() SpellBinder:Toggle() end)
		SpellBinderFrameCloseButton:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameCloseButton:Enable()
		SpellBinderFrameCloseButton:SetTextColor(1, 1, 1)
		SpellBinderFrameCloseButton:SetText(L["Close"])
		previousframe = SpellBinderFrameCloseButton

		
	--SET KEY button
		local SpellBinderFrameDoItButton = CreateFrame("Button","SpellBinderFrameDoItButton",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameDoItButton:SetFrameStrata("DIALOG")
		SpellBinderFrameDoItButton:SetWidth(100)
		SpellBinderFrameDoItButton:SetHeight(24)
		SpellBinderFrameDoItButton:SetPoint("BOTTOMLEFT",SpellBinderFrame, 10, 10)
		SpellBinderFrameDoItButton:RegisterForClicks("LeftButtonUp")
		SpellBinderFrameDoItButton:SetScript("OnClick", function() SpellBinder:Set() end)
		SpellBinderFrameDoItButton:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameDoItButton:Disable()
		SpellBinderFrameDoItButton:SetTextColor(1, 1, 1)
		SpellBinderFrameDoItButton:SetText(L["Set Key"])
		previousframe = SpellBinderFrameDoItButton

	--TEXTS
		local SpellBinderFrameTopText = SpellBinderFrame:CreateFontString("SpellBinderFrameTopText","DIALOG")
		SpellBinderFrameTopText:SetPoint("BOTTOM", SpellBinderFrame, "TOP", 0, 0)
		SpellBinderFrameTopText:SetFontObject("GameTooltipHeaderText")
		SpellBinderFrameTopText:SetTextColor(1, 1, 1)
		SpellBinderFrameTopText:SetText(L["SpellBinder Title"])
		
		local SpellBinderFrameBindText = SpellBinderFrame:CreateFontString("SpellBinderFrameBindText","DIALOG")
		SpellBinderFrameBindText:SetPoint("BOTTOMRIGHT", SpellBinderFrameKeyBindButton1, "TOPRIGHT", 0, 5)
		SpellBinderFrameBindText:SetFontObject("GameFontNormal")	--("GameTooltipTextSmall")
		SpellBinderFrameBindText:SetTextColor(1, 1, 1)
		SpellBinderFrameBindText:SetWidth(140)
		
		local SpellBinderFrameInfoText = SpellBinderFrame:CreateFontString("SpellBinderFrameInfoText","DIALOG")
		SpellBinderFrameInfoText:SetPoint("BOTTOMLEFT", SpellBinderFrame, "BOTTOMLEFT", 10, 40)
		SpellBinderFrameInfoText:SetFontObject("GameTooltipTextSmall")
		SpellBinderFrameInfoText:SetTextColor(1, 1, 1)
		
	--SPELL/ITEM/MACRO TEXTURE
		local SpellBinderFrameActionTexture = SpellBinderFrame:CreateTexture("SpellBinderFrameActionTexture","DIALOG")
		SpellBinderFrameActionTexture:SetPoint("BOTTOM", SpellBinderFrameBindText, "TOP", 0, 0)
		SpellBinderFrameActionTexture:SetWidth(32)
		SpellBinderFrameActionTexture:SetHeight(32)
		
	--KEYSTATE button
		local SpellBinderFrameKeystateButton = CreateFrame("Button","SpellBinderFrameKeystateButton",SpellBinderFrame,"UIPanelButtonTemplate2")
		SpellBinderFrameKeystateButton:SetFrameStrata("DIALOG")
		SpellBinderFrameKeystateButton:SetWidth(120)
		SpellBinderFrameKeystateButton:SetHeight(24)
		SpellBinderFrameKeystateButton:SetPoint("BOTTOM", SpellBinderFrame, "BOTTOM", 0, 10)
		SpellBinderFrameKeystateButton:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
		SpellBinderFrameKeystateButton:SetScript("OnClick", function() SpellBinder:ToggleKeystate() end)
		SpellBinderFrameKeystateButton:SetFont("GameFontHighlightSmall",12)
		SpellBinderFrameKeystateButton:Enable()
		SpellBinderFrameKeystateButton:SetTextColor(1, 1, 1)
		SpellBinderFrameKeystateButton:SetText("Keystate: "..(SpellBinder_Keystate or "down"))
		previousframe = SpellBinderFrameKeystateButton
		
		SpellBinderFrame:Hide()

		self:SPELLS_CHANGED()
	end
	if SpellBinderFrame:IsVisible() then
		SpellBinderFrame:Hide()
	else
		SpellBinderFrame:Show()
		currentitem=nil
		currentbind1=nil
		currentbind2=nil
		SpellBinderFrameKeyBindButton1:SetText(L["Click to Set"])
		SpellBinderFrameKeyBindButton2:SetText(L["Click to Set"])
		SpellBinderFrameInfoText:SetText("")
		SpellBinder:UpdateText()
		if SpellBinderFrameSpellBook1Button:GetText()==nil then
			SpellBinder:SPELLS_CHANGED()
		end
	end
end

function SpellBinder:Press(frame, button, arg1)
--DEBUG	print(frame) print(button) print(arg1)
	if awaitinginput==false then
		_G["SpellBinderFrameKeyBindButton"..frame]:EnableKeyboard(true)
		_G["SpellBinderFrameKeyBindButton"..frame]:EnableMouseWheel(true)
		awaitinginput=true
		_G["SpellBinderFrameKeyBindButton"..frame]:SetText(L["Enter Key Combo"])
		SpellBinderFrameInfoText:SetText(L["Left click binding button to unbind"])
		return
	end

	local screenshotKey = GetBindingKey("SCREENSHOT")
	if screenshotKey and arg1 == screenshotKey then
		Screenshot()
		return
	end

	if button == "LeftButton" then
		button = "BUTTON1"
	elseif button == "RightButto" then
		button = "BUTTON2"
	elseif button == "MiddleButton" then
		button = "BUTTON3"
	elseif button == "Button4" then
		button = "BUTTON4"
	elseif button == "Button5" then
		button = "BUTTON5"
	end
	local keyPressed = arg1
	if button then
		if button == "BUTTON1" or button == "BUTTON2" then
			_G["SpellBinderFrameKeyBindButton"..frame]:SetText(L["Click to Set"])
			_G["SpellBinderFrameKeyBindButton"..frame]:EnableKeyboard(false)
			_G["SpellBinderFrameKeyBindButton"..frame]:EnableMouseWheel(false)
			awaitinginput=false
			if frame == 1 then
				if currentbind1 then
					SetBinding(currentbind1)
					SpellBinder:UnregisterKey(currentbind1)
				end
				currentbind1=currentbind2
				currentbind2=nil
			else
				if currentbind2 then
					SetBinding(currentbind2)
					SpellBinder:UnregisterKey(currentbind2)
				end
				currentbind2=nil
			end
			SpellBinderFrameInfoText:SetText("")
			self:UpdateText()
			SaveBindings(GetCurrentBindingSet())
			return
		end
		keyPressed = button
	else
		keyPressed = arg1
	end
	if keyPressed == "UNKNOWN" or  keyPressed == "ESCAPE" then
		self:Toggle()
		return
	end
	--[[
	if keyPressed:match(".SHIFT") or keyPressed:match(".CTRL") or keyPressed:match(".ALT") then
		return
	end]]
	if keyPressed == "SHIFT" or keyPressed == "CTRL" or keyPressed == "ALT" then
		return
	end
	if IsShiftKeyDown() then
		keyPressed = "SHIFT-"..keyPressed
	end
	if IsControlKeyDown() then
		keyPressed = "CTRL-"..keyPressed
	end
	if IsAltKeyDown() then
		keyPressed = "ALT-"..keyPressed
	end
	awaitinginput=false
	_G["SpellBinderFrameKeyBindButton"..frame]:EnableKeyboard(false)
	_G["SpellBinderFrameKeyBindButton"..frame]:EnableMouseWheel(false)
	_G["SpellBinderFrameKeyBindButton"..frame]:SetText(keyPressed)
	local oldkey = SpellBinder:GetBindingAction(SpellBinder:GetSpecialXMLChars(keyPressed))
	if string.len(oldkey) > 1 then
		SpellBinderFrameInfoText:SetText(keyPressed..L[" bound to "]..oldkey)
	end
	if frame == 1 then
		currentbind1=keyPressed
	else
		if currentbind1 then
			currentbind2=keyPressed
		else
			currentbind1=keyPressed
		end
	end
	self:UpdateText()
end
function SpellBinder:UpdateText()
	SpellBinderFrameBindText:SetText(currentitem)
	SpellBinderFrameActionTexture:SetTexture(SpellBinder:GetTexture(currentmode, currentitem) or "")
	if currentitem == nil then
		currentbind1=nil
		currentbind2=nil
	end
	if currentbind1 then
		SpellBinderFrameKeyBindButton1:SetText(currentbind1)
	else
		SpellBinderFrameKeyBindButton1:SetText(L["Click to Set"].." 1")
	end
	if currentbind2 then
		SpellBinderFrameKeyBindButton2:SetText(currentbind2)
	else
		SpellBinderFrameKeyBindButton2:SetText(L["Click to Set"].." 2")
	end
	if currentitem then
		SpellBinderFrameKeyBindButton1:Enable()
		SpellBinderFrameKeyBindButton2:Enable()
		if currentbind1 then
			SpellBinderFrameDoItButton:Enable()
		else
			SpellBinderFrameDoItButton:Disable()
		end
	else
		SpellBinderFrameKeyBindButton1:Disable()
		SpellBinderFrameKeyBindButton2:Disable()
	end
end
function SpellBinder:ClickBookButton(num)
	if num == 5 then
		dewdrop:Open(_G["SpellBinderFrameSpellBook"..num.."Button"],
		'children', function(ar1, ar2)
			if ar1==1 then
				local numSpells = HasPetSpells()
				local multirankedspells={}
				for i=1,numSpells do
					local spell, rank = GetSpellName(i, BOOKTYPE_PET)
					local nextspell = GetSpellName(i+1, BOOKTYPE_PET)
					local passive = nil	--IsPassiveSpell(i, BOOKTYPE_PET)
					if not passive then
						if ((nextspell and nextspell~=spell) or (not nextspell)) and multirankedspells[spell]==nil then
							if string.len(rank)>2 then
								dewdrop:AddLine(
									'text', spell.."("..rank..")",
									'func', function()
										currentitem=spell.."("..rank..")"
										currentmode="spell"
										currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
										currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
										SpellBinder:UpdateText()
										dewdrop:Close()
									end
								)
							else
								dewdrop:AddLine(
									'text', spell,
									'func', function()
										currentitem=spell
										currentmode="spell"
										currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
										currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
										SpellBinder:UpdateText()
										dewdrop:Close()
									end
								)
							end
						elseif multirankedspells[spell]==nil then
							multirankedspells[spell]=true
							dewdrop:AddLine(
								'text', spell,
								'value', spell,
								'hasArrow', true
							)
						end
					end
				end
			elseif ar1==2 then
				local _, _, offset, numSpells = GetSpellTabInfo(num)
				for i=(1+offset),(offset+numSpells) do
					local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
					if spell==ar2 then
						dewdrop:AddLine(
							'text', spell.."("..rank..")",
							'func', function()
								currentitem=spell.."("..rank..")"
								currentmode="spell"
								currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
								currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
								SpellBinder:UpdateText()
								dewdrop:Close()
							end
						)
					end
				end
				dewdrop:AddLine(
					'text', L["Use No Rank (Will Always Cast Highest)"],
					'func', function()
						currentitem=ar2
						currentmode="spell"
						currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
						currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
						SpellBinder:UpdateText()
						dewdrop:Close()
					end
				)
			end
		end)
	else
		dewdrop:Open(_G["SpellBinderFrameSpellBook"..num.."Button"],
		'children', function(ar1, ar2)
			if ar1==1 then
				local _, _, offset, numSpells = GetSpellTabInfo(num)
				local multirankedspells={}
				for i=(1+offset),(offset+numSpells) do
					local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
					local nextspell = GetSpellName(i+1, BOOKTYPE_SPELL)
					local passive = nil --IsPassiveSpell(i, BOOKTYPE_SPELL)
					if not passive then
						if ((nextspell and nextspell~=spell) or (not nextspell)) and multirankedspells[spell]==nil then
							if string.len(rank)>2 then
								dewdrop:AddLine(
									'text', spell.."("..rank..")",
									'func', function()
										currentitem=spell.."("..rank..")"
										currentmode="spell"
										currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
										currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
										SpellBinder:UpdateText()
										dewdrop:Close()
									end
								)
							else
								dewdrop:AddLine(
									'text', spell,
									'func', function()
										currentitem=spell
										currentmode="spell"
										currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
										currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
										SpellBinder:UpdateText()
										dewdrop:Close()
									end
								)
							end
						elseif multirankedspells[spell]==nil then
							multirankedspells[spell]=true
							dewdrop:AddLine(
								'text', spell,
								'value', spell,
								'hasArrow', true
							)
						end
					end
				end
			elseif ar1==2 then
				local _, _, offset, numSpells = GetSpellTabInfo(num)
				for i=(1+offset),(offset+numSpells) do
					local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
					if spell==ar2 then
						dewdrop:AddLine(
							'text', spell.."("..rank..")",
							'func', function()
								currentitem=spell.."("..rank..")"
								currentmode="spell"
								currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
								currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
								SpellBinder:UpdateText()
								dewdrop:Close()
							end
						)
					end
				end
				dewdrop:AddLine(
					'text', L["Use No Rank (Will Always Cast Highest)"],
					'func', function()
						currentitem=ar2
						currentmode="spell"
						currentbind1, currentbind2=GetBindingKey("SPELL "..currentitem)
						currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
						SpellBinder:UpdateText()
						dewdrop:Close()
					end
				)
			end
		end)
	end
end
function SpellBinder:ClickMacroButton()
	local allmacros = ""
	local warned = false
	dewdrop:Open(SpellBinderFrameMacroButton,
	'children', function(ar1, ar2)
		local numglobal,numchar = GetNumMacros()
		for i=1,numglobal do
			local name = GetMacroInfo(i)
			dewdrop:AddLine(
				'text', name,
				'func', function()
					currentitem=name
					currentmode="macro"
					currentbind1, currentbind2=GetBindingKey("MACRO "..currentitem)
					currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
					SpellBinder:UpdateText()
					dewdrop:Close()
				end
			)
			if allmacros == ":"..name..":" and not warned then
				SpellBinder:Print(L["Warning"])
				warned = true
			end
			allmacros = allmacros..":"..name..":"
		end
		for i=19,(numchar+18) do
			local name = GetMacroInfo(i)
			dewdrop:AddLine(
				'text', name,
				'func', function()
					currentitem=name
					currentmode="macro"
					currentbind1, currentbind2=GetBindingKey("MACRO "..currentitem)
					currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
					SpellBinder:UpdateText()
					dewdrop:Close()
				end
			)
			if allmacros == ":"..name..":" and not warned then
				SpellBinder:Print(L["Warning"])
				warned = true
			end
			allmacros = allmacros..":"..name..":"
		end
	end)
end
function SpellBinder:ClickItemButton()
	dewdrop:Open(SpellBinderFrameItemButton,
	'children', function(ar1, ar2)
		dewdrop:AddLine(
			'text', L["Enter Exact Item Name or Drag and Drop"],
			'hasArrow', true,
			'hasEditBox', true,
			'editBoxFunc', function(text)
				currentitem=text
			--	if currentitem:match("%|h%[(.+)%]%|h") then
			--		currentitem = currentitem:match("%|h%[(.+)%]%|h")
			--	end
				if string.find(currentitem, "%[") then
					currentitem = string.gsub(string.gsub(currentitem, "(%[+)", "", 1), "(%]+)", "", 1)
				end
				currentmode="item"
				currentbind1, currentbind2=GetBindingKey("ITEM "..currentitem)
				currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
				SpellBinder:UpdateText()
				dewdrop:Close()
			end
		)
	end)
end

SpellBinder_bound = {
	ITEM = {},
	SPELL = {},
	MACRO = {},
}
function SpellBinder:MakeListMenu()
	local unavaible = false
	if unavaible then
		print("SpellBinder: List currently unavaible")
		return false;
	end
	for k, v in pairs(SpellBinder_bound) do
		for k in pairs(v) do
			v[k] = nil
		end
	end
	for _, key in ipairs(bindables) do
		for _, modifier in ipairs(modifiers) do
			local action = SpellBinder:GetBindingAction(modifier..key)	--GetBindingAction(modifier..key)
			if action then
				local spell = string.find(action, "^SPELL")	--action:match('^SPELL (.+)$')
				if spell then
					spell = string.gsub(action, "SPELL ", "", 1)
					local t = SpellBinder:GetKeyAction(modifier..key)
					if t == nil then t = {}; t.arg = spell end
					SpellBinder_bound.SPELL[modifier..key] = t.arg	--spell
				end
				local item = string.find(action, "^ITEM")	--action:match('^ITEM (.+)$')
				if item then
					item = string.gsub(action, "SPELL ", "", 1)
					local t = SpellBinder:GetKeyAction(modifier..key)
					if t == nil then t = {}; t.arg = item end
					SpellBinder_bound.ITEM[modifier..key] = t.arg	--item
				end
				local macro = string.find(action, "^MACRO")	--action:match('^MACRO (.+)$')
				if macro then
					macro = string.gsub(action, "SPELL ", "", 1)
					local t = SpellBinder:GetKeyAction(modifier..key)
					if t == nil then t = {}; t.arg = macro end
					SpellBinder_bound.MACRO[modifier..key] = t.arg	--macro
				end
			end
		end
	end
	dewdrop:Open(SpellBinderFrameListButton,
		'children', function(ar1, ar2)
			if ar1==1 then
				dewdrop:AddLine('text', L["Spell"], 'hasArrow', true, 'value', "SPELL")
				dewdrop:AddLine('text', L["Item"], 'hasArrow', true, 'value', "ITEM")
				dewdrop:AddLine('text', L["Macro"], 'hasArrow', true, 'value', "MACRO")
			elseif ar1==2 then
				if ar2 == 'SPELL' then
					for key, spellname in pairs(SpellBinder_bound.SPELL) do
						local spellname = spellname
						local key = key
						dewdrop:AddLine(
							'text', spellname..' - '..key,
							'func', function()
								currentitem = spellname
								currentmode = 'spell'
								currentbind1, currentbind2 = GetBindingKey("SPELL "..spellname)
								currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
								SpellBinder:UpdateText()
								dewdrop:Close()
							end
						)
					end
				elseif ar2 == 'ITEM' then
					for key, itemname in pairs(SpellBinder_bound.ITEM) do
						local itemname = itemname
						local key = key
						dewdrop:AddLine(
							'text', itemname..' - '..key,
							'func', function()
								currentitem = itemname
								currentmode = 'item'
								currentbind1, currentbind2 = GetBindingKey("ITEM "..itemname)
								currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
								SpellBinder:UpdateText()
								dewdrop:Close()
							end
						)
					end
				else --MACRO
					for key, macroname in pairs(SpellBinder_bound.MACRO) do
						local macroname = macroname
						local key = key
						dewdrop:AddLine(
							'text', macroname..' - '..key,
							'func', function()
								currentitem = macroname
								currentmode = 'macro'
								currentbind1, currentbind2 = GetBindingKey("MACRO "..macroname)
								currentbind1, currentbind2 = SpellBinder:ReturnRegisteredKeys(currentbind1, currentbind2)
								SpellBinder:UpdateText()
								dewdrop:Close()
							end
						)
					end
				end
			end
		end)


end
function SpellBinder:Set()
	--[[
	if InCombatLockdown() then
		self:Print(L["Cannot bind keys while in combat"])
		return
	end]]
	local clear1, clear2, success1, success2
	if currentmode == "spell" then
		clear1, clear2 = GetBindingKey("SPELL "..currentitem)
		if clear1 then
			SetBinding(clear1)
		end
		if clear2 then
			SetBinding(clear2)
		end
		SetBinding(currentbind1)
	--	SetBinding(currentbind1, "SPELL "..currentitem);	--SetBindingSpell(currentbind1, currentitem)
		success1 = SpellBinder:AssignKey(currentmode, currentbind1, currentitem)
		if currentbind2 then
			SetBinding(currentbind2)
		--	SetBinding(currentbind2, "SPELL "..currentitem)	--SetBindingSpell(currentbind2, currentitem)
			success2 = SpellBinder:AssignKey(currentmode, currentbind2, currentitem)
		end
	elseif currentmode == "macro" then
		if tonumber(currentitem) then	--currentitem:match("^(%d+)$") then
			self:Print(L["NumWarn"])
		end
		clear1, clear2 = GetBindingKey("MACRO "..currentitem)
		if clear1 then
			SetBinding(clear1)
		end
		if clear2 then
			SetBinding(clear2)
		end
		SetBinding(currentbind1)
	--	SetBinding(currentbind1, "MACRO "..currentitem)	--SetBindingMacro(currentbind1, currentitem)
		success1 = SpellBinder:AssignKey(currentmode, currentbind1, currentitem)
		if currentbind2 then
			SetBinding(currentbind2)
		--	SetBinding(currentbind2, "MACRO "..currentitem)	--SetBindingMacro(currentbind2, currentitem)
			success2 = SpellBinder:AssignKey(currentmode, currentbind2, currentitem)
		end
	elseif currentmode == "item" then
		clear1, clear2 = GetBindingKey("ITEM "..currentitem)
		if clear1 then
			SetBinding(clear1)
		end
		if clear2 then
			SetBinding(clear2)
		end
		SetBinding(currentbind1)
	--	SetBinding(currentbind1, "ITEM "..currentitem)	--SetBindingItem(currentbind1, currentitem)
		success1 = SpellBinder:AssignKey(currentmode, currentbind1, currentitem)
		if currentbind2 then
			SetBinding(currentbind2)
		--	SetBinding(currentbind2, "ITEM "..currentitem)	--SetBindingItem(currentbind2, currentitem)
			success2 = SpellBinder:AssignKey(currentmode, currentbind2, currentitem)
		end
	end
	if currentbind2 and success2 then
		if ( GetLocale() == "koKR" ) then
			SpellBinder:Print(currentitem.."의 단축키 설정을 "..currentbind1.." 그리고 "..currentbind2.."|1로;으로; 설정합니다.")
		else
			SpellBinder:Print("Set "..currentitem.." to "..currentbind1.." and "..currentbind2)
		end
	elseif success1 then
		if ( GetLocale() == "koKR" ) then
			SpellBinder:Print(currentitem.."의 단축키 설정을 "..currentbind1.."|1로;으로; 설정합니다.")
		else
			SpellBinder:Print("Set "..currentitem.." to "..currentbind1)
		end
	end
	currentmode=nil
	currentitem=nil
	currentbind1=nil
	currentbind2=nil
	SpellBinderFrameKeyBindButton1:SetText(L["Click to Set"])
	SpellBinderFrameKeyBindButton2:SetText(L["Click to Set"])
	SpellBinderFrameInfoText:SetText("")
	SpellBinderFrameDoItButton:Disable()
	self:UpdateText()
	SaveBindings(GetCurrentBindingSet())
	SpellBinder:UnregisterKeys()
end
function SpellBinder:SPELLS_CHANGED()
	if not SpellBinderFrame then
		return
	end
	for i=1,GetNumSpellTabs() do
		local name=GetSpellTabInfo(i)
		_G["SpellBinderFrameSpellBook"..i.."Button"]:SetText(name)
	end
	if HasPetSpells() then
		SpellBinderFrameSpellBook5Button:Enable()
	else
		SpellBinderFrameSpellBook5Button:Disable()
	end
end

--get special XML chars
function SpellBinder:GetSpecialXMLChars(key)
	--print("Key == "..key)
	for k,v in pairs(specialxmlchars) do
		if k == key then
		--	print("k == key") print("key to return: "..v)
			key = v
		elseif v == key then
		--	print("v == key") print("key to return: "..k)
			key = k
		end
	end
	return key
end

--set keystate
function SpellBinder:ToggleKeystate()
	local k = SpellBinder_Keystate
	if not k or k == "up" then
		k = "down"
	else
		k = "up"
	end
	SpellBinder_Keystate = k
	SpellBinderFrameKeystateButton:SetText("Keystate: "..SpellBinder_Keystate)
end

--Set key handler
function SpellBinder:AssignKey(type, key, arg)
	local found = false
	for i, m in ipairs(modifiers) do
		for k,v in ipairs(bindables) do
			local k = m..v
			if k == key then
				found = true
				break;
			end
		end
	end
	if not found then SpellBinder:Print("Incorrect key: "..(key or "nil")) return false end
	if type ~= "spell" and type ~= "macro" and type ~= "item" then SpellBinder:Print("Invalid type"..(type or "nil")) return false end
	
	local t = {}	
	t.type = type
	t.arg = arg
	t.key = key
	
	for k,v in pairs(t) do print(k.." = "..v) end
	
	local xmlkey = SpellBinder:GetSpecialXMLChars(key)
	
	SpellBinder_Assignments[xmlkey] = t
	
	SetBinding(key)
	SetBinding(key, "SpellBinder_KEY_"..xmlkey)
	
	return true;
	
end

--Check for registered keys
function SpellBinder:GetKeyAction(key)
	if SpellBinder_Assignments and SpellBinder_Assignments[key] then
		return SpellBinder_Assignments[key]
	end
	return
end

--get binding action
function SpellBinder:GetBindingAction(key)
	local str
	local k = SpellBinder:GetKeyAction(key)
	if k then
		str = string.upper(k.type).." "..k.arg
	else
		str = GetBindingAction(key)
	end
	return str
end

--return registered keys
local inprogress = false
function SpellBinder:ReturnRegisteredKeys(t1, t2)
	if inprogress then return end
	for k,v in pairs(SpellBinder_Assignments) do
		if v.arg == currentitem then
			if t1 == nil then
				t1 = v.key
			elseif t2 == nil then
				t2 = v.key
			end
		end
	end	
	inprogress = false
	return t1, t2
end

--unregister keys
function SpellBinder:UnregisterKey(key)
	key = SpellBinder:GetSpecialXMLChars(key)
	if SpellBinder_Assignments[key] then
		SpellBinder_Assignments[key] = nil
	end
end

local inprogress = false
function SpellBinder:UnregisterKeys()
	if inprogress then return end
	inprogress = true
	for i, m in ipairs(modifiers) do
		for k,v in ipairs(bindables) do
			local key1, key2 = GetBindingKey("SpellBinder_KEY_"..m..v)
			if key1 == nil and key2 == nil and SpellBinder_Assignments[m..v] then
				SpellBinder_Assignments[m..v] = nil
				SpellBinder:Print("deleted "..m..v)
			end
		end
	end
	inprogress = false
end

--ChatBox Execution
function SpellBinder:Execute_Command(command)
-- Simple function to execute a string as though it were typed in the chat box
	SpellBinder_Command_EditBox:SetText(command)
	local editbox = SpellBinder_Command_EditBox
	ChatEdit_SendText(editbox)
end

--RunMacro API
function RunMacro(arg)

	--lookup macroID if arg is a string (macro name)
	if type(arg) == "string" and not tonumber(arg) then
		arg = GetMacroIndexByName(arg)
	end
	--[[
	if type(arg) == "string" and not tonumber(arg) then
		local found = false
		local numglobal,numchar = GetNumMacros()
		for i=1,numglobal do
			local name = GetMacroInfo(i)
			if name == arg then
				arg = i
				found = true
				break;
			end
		end
		if not found then
			for i=19,(numchar+18) do
				local name = GetMacroInfo(i)
				if name == arg then
					arg = i
					found = true
					break;
				end
			end
		end
	end]]

	name, iconTexture, body, isLocal = GetMacroInfo(arg);
	SpellBinder:Execute_Command(body)
end
function RunMacroText(arg)
	arg = tostring(arg)
	SpellBinder:Execute_Command(arg)
end

local function GetItemNameFromLink( itemLink )
	local _,_,itemLinkName = string.find( itemLink, "|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[(.-)%]|h|r" )
	return itemLinkName
end

local function FindItemInBags( itemName )
	for container = 0, 4 do
		for slot = 1, GetContainerNumSlots( container ) do
			itemLink = GetContainerItemLink( container, slot )
			
			if ( itemLink ) then
				local bagItemName = GetItemNameFromLink( itemLink )
				if ( bagItemName == itemName ) then
					return container, slot;
				end
			end
		end
	end
end

local function FindItemInInventory( itemName )
	for slot = 0, 19 do
		itemLink = GetInventoryItemLink( "player", slot )

		if ( itemLink ) then
			local invItemName = GetItemNameFromLink( itemLink )
			
			if ( invItemName == itemName ) then
				return slot;
			end
		end
	end
end


--UseItem API
function SpellBinder:UseItem(arg)
	local container, slotID = FindItemInBags(arg)
	local invSlotID = FindItemInInventory(arg)
	
	if container then
		UseContainerItem(container, slotID)	--3rd arg:	onSelf >> Boolean - Optional parameter, if the item should be used on yourself (default: false).
	--	return true;
	elseif invSlotID then
		UseInventoryItem(invSlotID)
	--	return true;
	end
--	return false;
end

--Perform specified action from key
function SpellBinder:PerformAction(key)
	local t = SpellBinder:GetKeyAction(key)
	if not t or t == nil or t == {} or not t.type or not t.arg then
		print("no table")
		return
	end
	if t.type == "spell" then
		CastSpellByName(t.arg)
	elseif t.type == "item" then
		SpellBinder:UseItem(t.arg)
	elseif t.type == "macro" then
		RunMacro(t.arg)
	end
end

function SpellBinder:CheckDB()
	for k,v in pairs(SpellBinder_Assignments) do
		local bindingaction = GetBindingAction(v.key)
		local SBbindingname = "SpellBinder_KEY_"..v.key
		if bindingaction ~= SBbindingname then
			SpellBinder:Print("Key '"..v.key.."' is not correctly bound.\nIt should be bound to '"..string.upper(v.type).." "..v.arg.."'.")
		end
	end
end


local inprogress = false
function SpellBinder:CreateButtonTable()
	if inprogress then return end
	inprogress = true
--	SpellBinder_Assignments.table = {}
	local count = 0
	local str = ""
	for i, m in ipairs(modifiers) do
		for k,v in ipairs(bindables) do
			v = SpellBinder:GetSpecialXMLChars(v)
			local keystr = "<Binding name=/zSpellBinder_KEY_"..m..v.."/z runOnUp=/ztrue/z hidden=/ztrue/z>/nif ( keystate == SpellBinder_Keystate ) then/nSpellBinder:PerformAction(/z"..m..v.."/z)/nend/n</Binding>"
		--	SpellBinder_Assignments.table[getn(SpellBinder_Assignments.table)+1] = keystr
			str = str..keystr
			count = count+1
		end
	end
	SpellBinder_Assignments.strings = str
	SpellBinder:Print(count.." keys created")
	inprogress = false
end

local inprogress = false
function SpellBinder:XML()
	if inprogress then return end
	inprogress = true
	local t = {}
	for i, m in ipairs(modifiers) do
		for k, v in ipairs(specialxml) do
			t[m..v] = m..v
		end
	end
	SpellBinder_Assignments.specialxmlchars = t
	inprogress = false
end


function SpellBinder:GetTexture(type, value)
	if not type or not value then print("Invalid args") return end
	
	local texture = nil
	
	if type == "spell" then
		for tabIndex = 1, MAX_SKILLLINE_TABS do
			local tabName, tabTexture, tabSpellOffset, tabNumSpells = GetSpellTabInfo(tabIndex)
			
			if not tabName then break end
			
			for spellIndex = tabSpellOffset + 1, tabSpellOffset + tabNumSpells do
				local spellName, spellRank = GetSpellName(spellIndex, BOOKTYPE_SPELL)
				local spellNameWRank = spellName.."("..spellRank..")"

				if spellNameWRank == value then				
					texture = GetSpellTexture(spellIndex, BOOKTYPE_SPELL)
					break				
				elseif spellName == value then
					texture = GetSpellTexture(spellIndex, BOOKTYPE_SPELL)
					break
				end
			end
		end
	elseif type == "item" then
		for b = 0, NUM_BAG_SLOTS do
			if GetBagName(b) then
				for i = 1, GetContainerNumSlots(b) do
					if GetContainerItemName(b, i) == value then
						texture = GetContainerItemInfo(b, i)
						break
					end
				end
			end
		end
		for i = 0, 19 do
			if GetInventoryItemName("player", i) == value then
				texture = GetInventoryItemTexture("player", i)
			end
		end
	elseif type == "macro" then
		for i = 1, GetNumMacros() do	--global
			local name, iconTexture, body, isLocal = GetMacroInfo(i)
			if name == value then
				texture = iconTexture
			end
		end
		for i = 1, select(2,GetNumMacros()) do	--character
			local name, iconTexture, body, isLocal = GetMacroInfo(i)
			if name == value then
				texture = iconTexture
			end
		end
	end
	
	return texture
end

--[[
	EXPERIMENTAL	-----------------------------------------------------------------------------------------
]]

--AutoUnstuck when using Hearthstone
local itemtable = {
	[6948] = Stuck
}
function SpellBinder:UseAutoUnstuck()

	old_UseContainerItem = UseContainerItem
	
	local function new_UseContainerItem(container, slotID)
	--	print(container) print(slotID)
		local itemID = GetContainerItemID(container, slotID)
	--	print(itemID)
		if itemID and itemtable[itemID] then
			--print("do special")
			itemtable[itemID]()
		else
			old_UseContainerItem(container, slotID)
		end
	end

	UseContainerItem = new_UseContainerItem
end

function GetContainerItemID(container, slotID)
	if not container or container == nil or not slotID or slotID == nil then print("GetContainerItemID: Wrong/Unknown parameter") return nil end
	local itemLink = GetContainerItemLink(container, slotID)
	if not itemLink or itemLink == nil then
		return nil
	end
	local itemLink = select(3,string.find(itemLink,"(item:%d+)"))
	local itemID = string.gsub(itemLink, "item:", "")
	itemID = tonumber(itemID)
	return itemID
end

function GetContainerItemName(container, slotID)
	if not container or container == nil or not slotID or slotID == nil then print("GetContainerItemName: Wrong/Unknown parameter") return nil end
	local itemLink = GetContainerItemLink(container, slotID)
	if not itemLink or itemLink == nil then
		return nil
	end
	--string.gsub(string.gsub(currentitem, "(%[+)", "", 1), "(%]+)", "", 1)
	local itemLink = select(3,string.find(itemLink,"(%[.*%])"))
	local itemName = string.gsub(string.gsub(itemLink, "(%[+)", "", 1), "(%]+)", "", 1)
	return itemName
end

function GetInventoryItemName(unit, invSlot)
	if not unit or unit == nil or not invSlot or invSlot == nil then print("GetInventoryItemName: Wrong/Unknown parameter") return nil end
	local itemLink = GetInventoryItemLink(unit, invSlot)
	if not itemLink or itemLink == nil then
		return nil
	end
	--string.gsub(string.gsub(currentitem, "(%[+)", "", 1), "(%]+)", "", 1)
	local itemLink = select(3,string.find(itemLink,"(%[.*%])"))
	local itemName = string.gsub(string.gsub(itemLink, "(%[+)", "", 1), "(%]+)", "", 1)
	return itemName
end

function GetInventoryItemID(unit, invSlot)
	if not unit or unit == nil or not invSlot or invSlot == nil then print("GetInventoryItemID: Wrong/Unknown parameter") return nil end
	local itemLink = GetInventoryItemLink(unit, invSlot)
	if not itemLink or itemLink == nil then
		return nil
	end
	local itemLink = select(3,string.find(itemLink,"(item:%d+)"))
	local itemID = string.gsub(itemLink, "item:", "")
	itemID = tonumber(itemID)
	return itemID
end

